<template>
  <div
    v-if="modifiedColumns.length"
    ref="container"
    class="ob-table-inner"
    :class="{
      'tb_showMore': isShowMore,
      'tb_footer': functionalPanel,
      'th_header':!footerDisabled && sortedItems.length,
      '--with-data': Boolean(currentItems.length),
      '--with-pagination': showPagination,
      '--only-body': isLoadingWithNoneContentSlot,
      '--fixed-header': isFixedHeader
    }"
  >
    <!-- Блок отрисовки при отсутствии данных -->

    <transition name="fade">
      <div
        v-if="isShowNoneDataSlot"
        :class="{ '--with-func-panel': functionalPanel }"
        class="none-data-slot"
      >
        <slot name="noneContent" />
      </div>
    </transition>
    <!-- Конец блока отрисовки -->
    <!-- функциональная панель, для отображения functionalPanel: true -->
    <ob-func-panel
      v-if="functionalPanel"
      :style="{
        opacity: isLoading ? 0 : 1
      }"
      :columns="modifiedColumns"
      :show-add-button="showAddButton"
      :show-edit="showEdit"
      :show-refresh="showRefresh"
      :filter-buttons="filterButtons"
      :add-buttons="addButtons"
      :add-buttons-options="addButtonsOptions"
      :add-button-text="addButtonText"
      :show-hidden-length="showHiddenLength"
      :data-qa="dataQa"
      :show-sort="isFunctionalSort"
      :show-group="isFunctionalGroup"
      :show-column-filter="isFunctionalFilter"
      :show-search="isFunctionalSearch"
      @on-change-filter-button="onChangeFilterButton"
      @search="onSearch"
      @add="onAdd"
      @onEdit="onEdit"
      @onRefresh="onRefresh"
      @toggle-column-visibility="onToggleColumnVisibility"
    >
      <template
        v-if="$scopedSlots.extraFuncButtons"
        #buttons
      >
        <slot name="extraFuncButtons" />
      </template>
      <template
        v-if="$scopedSlots.extraFuncToPanel"
        #extraFuncToPanel
      >
        <slot name="extraFuncToPanel" />
      </template>
      <template
        v-if="$scopedSlots.controls"
        #controls
      >
        <slot name="controls" />
      </template>
    </ob-func-panel>
    <!-- конец функциональной панели -->
    <!-- Основной контейнер таблицы -->
    <div
      ref="tableItemObj"
      class="table-panel-inner"
      :class="{'table-panel-inner_isLoading' : isLoading}"
      :style="tablePanelInnerStyle"
      @scroll="checkShowMoreVisibility"
      @dragscrollstart="onDragStart"
      @click.capture="onDragClick"
    >
      <transition
        v-if="isLoading"
        name="fade"
      >
        <div class="ob-table-inner__loader-row">
          <div class="ob-table-inner__loader-column">
            <ob-loader
              :size="80"
              :delay="1000"
            />
          </div>
        </div>
      </transition>
      <table
        v-if="sortedItems.length || isLoading || filteredColumns.some(column => column._filters)"
        ref="tableDataObj"
        v-update="handleBodyUpdate"
        :style="[ { 'table-layout': tableLayoutFixed ? 'fixed' : 'auto' }, tableHeaderStyle ]"
        class="table-data"
      >
        <ob-header-table
          v-if="isHeader && (sortedItems.length || search || filteredColumns.some(column => column._filters))"
          :filtered-columns="filteredColumns"
          :table-columns-widths="tableColumnsWidths"
          :uuid-table="uuidTable"
          :fixed="true"
          :data-qa="dataQa"
          :show-header-checkbox="showHeaderCheckbox"
          :drag-hovered-column="dragHoveredColumn"
          :sort="sort"
          @onSort="onSorting"
          @onCheckAll="onCheckAll"
          @on-filter-changed="onFilterChanged"
        />
        <template v-if="!isUseGroups && !isUseSubTable">
          <ob-table-row
            v-for="(item, index) in currentItems"
            :key="item.item.uuid || index"
            :data="item"
            :options-save-item="optionsSaveRow"
            :filtered-columns="filteredColumns"
            :table-columns-widths="tableColumnsWidths"
            :class="tableRowClasses(item)"
            :data-qa="dataQa"
            :drag-hovered-column="dragHoveredColumn"
            @onSelect="onSelect($event)"
          >
            <template
              slot="obCheckbox"
              slot-scope="{ data }"
            >
              <div @click.stop>
                <ObCheckbox
                  :value="selectedUuids.includes(data.item.uuid)"
                  class="row-checkbox"
                  @change="onRowToggle(data.item, $event)"
                />
              </div>
            </template>

            <div
              v-for="(slot, indexSlot) in filteredColumnsItems"
              :slot="slot.slotName"
              :key="indexSlot"
              :slot-scope="item"
            >
              <slot
                :name="slot.slotName"
                :data="item"
              />
            </div>
          </ob-table-row>
        </template>
        <template v-else-if="isUseSubTable">
          <template v-for="(item, index) in currentItems">
            <ob-table-row
              :key="item.item.uuid || index"
              :data="item"
              :options-save-item="optionsSaveRow"
              :filtered-columns="filteredColumns"
              :table-columns-widths="tableColumnsWidths"
              :class="['sub-table-header', ...tableRowClasses(item)]"
              :data-qa="dataQa"
              :drag-hovered-column="dragHoveredColumn"
              @onSelect="toggleSubTableByClickAtWholeRow ? onSubTableToggle(item) : onSelect($event)"
            >
              <template
                slot="obSubTableToggler"
                slot-scope="{ data }"
              >
                <div @click.stop>
                  <!--
                  Когда включен toggleSubTableByClickAtWholeRow при клике на шеврон
                  сначала срабатывает клик по ob-table-row, вызывается onSubTableToggle
                  и отображение вложенной таблицы переключается,
                  потом срабатывает клик по шеврону и снова вызывается onSubTableToggle,
                  отображение вложенной таблицы переключается в предыдущее состояние
                  в итоге ничего не происходит. Для решения этого отключим обработку клика по шеврону
                  когда задан toggleSubTableByClickAtWholeRow
                  -->
                  <i
                    class="sub-table-header__arrow-toggle icon"
                    :class="item.item.isOpenedSubTable ? 'chevron-down' : 'chevron-right'"
                    @click="!toggleSubTableByClickAtWholeRow ? onSubTableToggle(item) : null"
                  />
                </div>
              </template>
              <template
                slot="obCheckbox"
                slot-scope="{ data }"
              >
                <div @click.stop>
                  <ObCheckbox
                    :value="selectedUuids.includes(data.item.uuid)"
                    class="row-checkbox"
                    @change="onRowToggle(data.item, $event)"
                  />
                </div>
              </template>

              <div
                v-for="(slot, indexSlot) in filteredColumnsItems"
                :slot="slot.slotName"
                :key="indexSlot"
                :slot-scope="item"
              >
                <slot
                  :name="slot.slotName"
                  :data="item"
                />
              </div>
            </ob-table-row>
            <tr
              v-if="item.item.isOpenedSubTable"
              :key="`sub-table-row-${item.item.uuid || index}`"
            >
              <td
                :colspan="filteredColumns.length"
                class="sub-table-body"
              >
                <ob-table
                  :ref="`sub-table-${item.item.uuid}`"
                  :columns="subColumns"
                  :functional-panel="false"
                  :remote-opt="subRemoteOptConfig(item)"
                  :is-header="false"
                  :is-sub-table="true"
                >
                  <template
                    v-for="(func, name) in $scopedSlots"
                    :slot="name"
                    slot-scope="{ data }"
                  >
                    <slot
                      :name="name"
                      :data="data"
                    />
                  </template>
                </ob-table>
              </td>
            </tr>
            <tr
              v-if="item.item.isOpenedSubTable && isSubTableAction"
              :key="`subTableAction-${item.item.uuid || index}`"
              class="has-action"
            >
              <td
                v-for="(column,subindex) in filteredColumns"
                :key="subindex"
              >
                <span
                  v-if="subindex === subTableAction.index"
                  class="subTableAction"
                  @click="$emit('subTableAction', item)"
                >
                  <i :class="['icon', subTableAction.icon]" />
                  {{ subTableAction.text }}
                </span>
              </td>
            </tr>
          </template>
        </template>
        <template v-else>
          <tbody
            v-for="(group, i) in groupCurrentList"
            :key="i"
            :class="groups[i] && !groups[i].opened && '--closed'"
          >
            <tr
              :data-qa="dataQa"
              @click="group.isStatic ? null : toggleGroup(i)"
            >
              <td :colspan="columns.length">
                <div class="groups-header --sticky">
                  <ObCheckbox
                    v-if="withCheckboxes"
                    :value="groupsState[i] && groupsState[i]._isChecked"
                    :type="groupsState[i] && groupsState[i]._isParticular ? 'particular' : 'default'"
                    class="groups-header__checkbox"
                    @change="onGroupToggle(i, $event)"
                  />

                  <i
                    v-if="!group.isStatic"
                    class="groups-header__arrow-toggle icon"
                    :class="groups[i] && groups[i].opened ? 'chevron-down' : 'chevron-right'"
                  />
                  <template v-if="groupSlotName">
                    <slot
                      :name="groupSlotName"
                      :data="group"
                    />
                  </template>
                  <div
                    v-else
                    class="groups-header__title"
                  >
                    <template v-if="groupTitleHtml">
                      <span v-html="groupTitleHtml(group.value)" />
                    </template>
                    <template v-else>
                      {{ group.value }}
                    </template>
                  </div>
                </div>
              </td>
            </tr>
            <ob-table-row
              v-for="(row, index) in groupCurrentList[i].items"
              :key="row.item.uuid || index"
              :filtered-columns="filteredColumns"
              :table-columns-widths="tableColumnsWidths"
              :data="row"
              :options-save-item="optionsSaveRow"
              :class="tableRowClasses(row, true)"
              :data-qa="dataQa"
              :drag-hovered-column="dragHoveredColumn"
              @onSelect="onSelect($event)"
            >
              <template
                slot="obCheckbox"
                slot-scope="{ data }"
              >
                <div @click.stop>
                  <ObCheckbox
                    :value="selectedUuids.includes(data.item.uuid)"
                    class="row-checkbox with-margin"
                    @change="onRowToggle(data.item, $event)"
                  />
                </div>
              </template>

              <div
                v-for="(slot, indexSlot) in filteredColumnsItems"
                :slot="slot.slotName"
                :key="indexSlot"
                :class="slot.slotName"
              >
                <slot
                  :name="slot.slotName"
                  :data="row"
                />
              </div>
            </ob-table-row>
            <tr
              v-if="isGroupAction"
              class="has-action"
            >
              <td
                v-for="(column,index) in filteredColumns"
                :key="index"
              >
                <span
                  v-if="index === groupAction.index"
                  class="groupAction"
                  @click="$emit('groupAction', group)"
                >
                  <i :class="['icon', groupAction.icon]" />
                  {{ groupAction.text }}
                </span>
              </td>
            </tr>
          </tbody>
        </template>
      </table>
      <div
        v-if="!sortedItems.length && !isLoading && (!Boolean($slots.noneContent) && !search) || ((search || filteredColumns.some(column => column._filters)) && !sortedItems.length)"
        class="table-empty"
      >
        <template v-if="search">
          По запросу
          <span style="color: #333;">"{{ search }}"</span>
          ничего не найдено
        </template>
        <template v-else>
          <div class="none-data-slot">
            <div class="none-content-title">
              Нет данных для отображения
            </div>
            <ObButton
              v-if="showAddButton"
              label="Добавить"
              type="flat"
              :data-qa="dataQa"
              @click="$emit('add')"
            />
          </div>
        </template>
      </div>
    </div>
    <!-- Конец контейнера таблицы -->
    <!-- Футер таблицы -->
    <div
      v-if="showFooter"
      class="table-footer"
    >
      <div class="total-count">
        Всего: {{ totalCount }}
      </div>
      <ob-pagination
        v-if="showPagination"
        :page="page"
        :count="totalCount"
        :page-limit="pageLimit"
        :is-page-input="true"
        :data-qa="dataQa"
        :is-wide="isPaginationWide"
        @onChangePage="onChangePage"
        @on-change="onChangePage"
      />
    </div>
    <!-- Конец футера таблицы -->
  </div>
</template>
<script>
import ObPagination from '../obPagination'
import ObFuncPanel from '../../obComponents/obFuncPanel'
import { uuid } from 'vue-uuid'
import ObLoader from '../obLoader'
import ObHeaderTable from './componentsTable/tableHeader'
import ObTableRow from './componentsTable/tableRow'
import ObButton from '../obButton'
import ObCheckbox from '../obCheckbox'
import { dragscroll } from 'vue-dragscroll'
import { getValueFromPath } from '../../helpers/common'
import cloneDeep from 'clone-deep'

export default {
  name: 'ObTable',
  directives: {
    update: {
      update: function (el, binding) {
        binding.value(el)
      }
    },
    dragscroll
  },
  components: {
    ObFuncPanel,
    ObPagination,
    ObLoader,
    ObHeaderTable,
    ObTableRow,
    ObButton,
    ObCheckbox
  },
  props: {
    isFixedHeader: {
      type: Boolean,
      default: () => false
    },
    isHeader: {
      type: Boolean,
      default: true
    },
    tableHeight: {
      type: Number,
      default: null
    },
    items: {
      type: Array,
      default: () => []
    },
    columns: {
      type: Array,
      required: true
    },
    functionalPanel: {
      type: Boolean,
      default: () => false
    },
    showAddButton: {
      type: Boolean,
      default: () => false
    },
    addButtonText: {
      type: String,
      default: () => 'Добавить'
    },
    footerDisabled: {
      type: Boolean,
      default: false
    },
    isCssSelectable: {
      type: Boolean,
      default: false
    },
    tableLayoutFixed: {
      type: Boolean,
      default: false
    },
    remoteOpt: {
      type: [Function, Object],
      default: null
    },
    remoteTrigger: {
      type: [String, Number, Object, Boolean],
      default: undefined
    },
    pageLimit: {
      type: [Number, String],
      default: 50
    },
    updateTimeout: {
      type: Number,
      default: null
    },
    showEdit: {
      type: Boolean,
      default: false
    },
    showRefresh: {
      type: Boolean,
      default: false
    },
    // for standalone func-panel
    searchQuery: {
      type: String,
      default: ''
    },
    groupBy: {
      type: String,
      default: null
    },
    groupTitleHtml: {
      type: Function,
      default: null
    },
    sortInit: {
      type: String,
      default: null
    },
    filterButtons: {
      type: Array,
      default: () => []
    },
    loading: {
      type: Boolean,
      default: false
    },
    addButtons: {
      type: Array
    },
    addButtonsOptions: {
      type: Object,
      default: () => {
        return {}
      }
    },
    optionsSaveRow: {
      type: Object,
      default: () => {
      }
    },
    showHiddenLength: {
      type: Boolean,
      default: false
    },
    isGroupsOpened: {
      type: Boolean,
      default: true
    },
    dataQa: {
      type: String
    },
    isFunctionalSort: {
      type: Boolean,
      default: true
    },
    isFunctionalGroup: {
      type: Boolean,
      default: true
    },
    isFunctionalFilter: {
      type: Boolean,
      default: true
    },
    isFunctionalSearch: {
      type: Boolean,
      default: true
    },
    isSmartPagination: {
      type: Boolean,
      default: true
    },
    withCheckboxes: {
      type: Boolean,
      default: false
    },
    rowClassFunc: {
      type: Function,
      default: () => ''
    },
    checkedRows: {
      type: Array,
      default: () => []
    },
    staticGroups: {
      type: Array,
      default: () => []
    },
    isGroupAction: {
      type: Boolean,
      default: false
    },
    groupAction: {
      type: Object
    },
    groupSlotName: {
      type: String
    },
    // for sub table
    isSubTable: {
      type: Boolean,
      default: false
    },
    subColumns: {
      type: Array
    },
    subRemoteOpt: {
      type: [Function, Object],
      default: null
    },
    isSubTableAction: {
      type: Boolean,
      default: false
    },
    subTableAction: {
      type: Object
    },
    toggleSubTableByClickAtWholeRow: {
      type: Boolean,
      default: false
    },
    showHeaderCheckbox: {
      type: Boolean,
      default: false
    },
    filtersHandler: {
      type: Function,
      default: null
    },
    componentUniqueKey: {
      type: String,
      default: null
    }
  },
  data () {
    return {
      dragged: false,
      dragTimeout: null,
      tableColumnsWidths: [],
      tableHeaderHeight: 0,
      tableHeaderTop: 0,
      activeItems: {
        prev: {},
        active: this.activeItem,
        next: {}
      },
      activeItem: {},
      search: this.searchQuery,
      sort: {
        key: null,
        type: null,
        direction: false
      },
      modifiedColumns: [],
      localItems: [],
      selectableItems: [],
      prevTrigger: undefined,
      firstLoad: true,
      isLocalLoading: true,
      page: 0,
      count: 0,
      isShowMore: false,
      groups: {},
      selectedUuids: [],
      uuidTable: uuid.v4(),
      isPaginationWide: false,
      openedSubTableStates: {},
      updateDataTO: null,
      filters: [],
      draggingCell: null,
      draggingCellIndex: null,
      draggingBlock: null,
      draggingBlockPosLeft: null,
      draggingBlockPosTop: null,
      draggingBlockWidth: null,
      draggingBlockHeight: null,
      isDragging: false,
      tableBound: null,
      cellsBound: [],
      dragHoveredColumn: null,
      sortDataForColumns: [],
      localOpenedGroups: {}
    }
  },
  computed: {
    filteredColumnsItems () {
      return this.filteredColumns.filter((i) => {
        return i.slotName
      })
    },
    tablePanelInnerStyle () {
      let res = {}
      if (this.isFixedHeader) {
        res.paddingTop = `${this.tableHeaderHeight - 1}px`
      }
      if (this.tableHeight) {
        res.height = `${this.tableHeight}px`
      }
      return res
    },
    tableHeaderStyle () {
      let res = {}
      if (this.isFixedHeader) {
        res.top = `${this.tableHeaderTop}px`
      }
      return res
    },
    isLoading () {
      return this.isLocalLoading || this.loading
    },
    currentList () {
      return this.localItems && this.localItems.length ? this.localItems : this.items
    },
    groupsList () {
      if (!this.groupBy) return null
      return Array.from(new Set(this.currentItems.map(item => getValueFromPath({ data: item.item, path: this.groupBy })))).map(item => item)
    },
    groupCurrentList () {
      if (!this.groupBy) return null
      let result = []
      this.groupsList.forEach((item) => {
        let obj = {
          value: item,
          isStatic: this.staticGroups.includes(item),
          items: this.currentItems.filter(data => getValueFromPath({ data: data.item, path: this.groupBy }) === item)
        }
        result.push(obj)
      })
      return result
    },
    isUseGroups () {
      return this.groupsList && this.groupsList.length
    },
    isUseSubTable () {
      return this.subColumns && this.subColumns.length
    },
    isRemote () {
      return this.isRemoteFunction || this.isRemoteObject
    },
    isRemoteFunction () {
      return this.remoteOpt && typeof this.remoteOpt === 'function'
    },
    isRemoteObject () {
      return this.remoteOpt && typeof this.remoteOpt === 'object' && this.remoteOpt.method
    },
    remoteTriggerStatus () {
      return this.remoteTrigger === undefined || this.remoteTrigger
    },
    isLoadReady () {
      return this.remoteTriggerStatus && this.isRemote
    },
    isChangeTrigger () {
      return this.remoteTrigger !== this.prevTrigger && this.remoteTrigger !== undefined && this.prevTrigger !== undefined
    },

    keys: ({ modifiedColumns }) => modifiedColumns
      .filter(column => column._isEnabled && !column.hasOwnProperty('html'))
      .map(column => column.key),

    itemsHaveAllProperties: ({ currentList, keys }) => currentList.every(item => keys.every(key => item.hasOwnProperty(key))),

    filteredColumns ({ modifiedColumns }) {
      const checkboxColumn = modifiedColumns.find(column => column.uuid === 'checkboxColumn')

      if (checkboxColumn) {
        // Checking for enabled columns, because if users has been disabled
        // all columns, column with the checkboxes need to hide
        const isAnyColumnEnabled = modifiedColumns.some(column => column !== checkboxColumn && column._isEnabled)

        checkboxColumn._isEnabled = this.withCheckboxes && isAnyColumnEnabled
      }

      return modifiedColumns.filter((column) => {
        column.isChange = false
        column.isFocus = false
        return column._isEnabled
      }).sort((a, b) => this.sortDataForColumnsObj[this.getUniqueColumnKey(a)] - this.sortDataForColumnsObj[this.getUniqueColumnKey(b)])
    },

    currentItems: ({ sortedItems, page, pageLimit, selectableItems, isRemote, totalCount, isSmartPagination }) => {
      if (isRemote) return selectableItems
      let start = page * pageLimit
      let end = (page + 1) * pageLimit

      if (isSmartPagination && totalCount < 100) return sortedItems

      return sortedItems.slice(start, end)
    },
    filteredItems: ({ selectableItems, search, filteredColumns, isRemote }) => {
      return search && !isRemote ? selectableItems.filter(data => {
        let filteredArr = []
        filteredColumns.forEach(column => {
          if (!column.hasOwnProperty('slotName')) {
            filteredArr.push(column.hasOwnProperty('html') ? column.html(data.item).replace(/<[^>]*>?/gm, '').replace(/\s\s+/g, ' ').trim() : data.item[column.key])
          }
        })
        return filteredArr.some(value => {
          return typeof value !== 'object' && typeof value !== 'undefined' ? value.toString().toLowerCase().includes(search.toLowerCase()) : false
        })
      }) : selectableItems
    },
    sortedItems: ({ sort, filteredItems, isRemote }) => {
      return sort.key && !isRemote ? filteredItems.sort((a, b) => {
        const first = sort.direction ? a : b
        const second = sort.direction ? b : a

        switch (sort.type) {
          case 'datetime':
            return new Date(first.item[sort.key]) - new Date(second.item[sort.key])
          default:
            return (second.item[sort.key] > first.item[sort.key]) - (second.item[sort.key] < first.item[sort.key])
        }
      }) : filteredItems
    },
    totalCount () {
      return this.isRemote ? this.count : this.sortedItems.length
    },
    showPagination () {
      if (this.isSmartPagination) {
        return Math.ceil(this.totalCount / +this.pageLimit) > 1 && this.totalCount > 100
      }

      return Math.ceil(this.totalCount / +this.pageLimit) > 1
    },
    isShowNoneDataSlot () {
      return Boolean(this.$slots.noneContent) && !this.search && !this.selectableItems.length
    },
    isLoadingWithNoneContentSlot () {
      return this.isLoading && Boolean(this.$slots.noneContent) && !this.search && !this.selectableItems.length
    },
    showFooter () {
      return !this.footerDisabled && this.totalCount > 10
    },
    groupsState () {
      // Can't using 'groups' array, because this array is changing in 'initGroups()' method
      const _tmp = []
      this.groupCurrentList.forEach((group, index) => {
        const _isChecked = Boolean(group.items.find(({ item: { uuid } }) => this.selectedUuids.includes(uuid)))
        const _isParticular = !group.items.every(({ item: { uuid } }) => this.selectedUuids.includes(uuid))

        _tmp.push({
          _isChecked,
          _isParticular
        })
      })
      return _tmp
    },
    hasSelectListener () {
      // If user can click to the table row for some action
      return this.$listeners.select
    },
    sortDataForColumnsObj () {
      const sortData = {}
      this.sortDataForColumns.forEach((column, index) => {
        sortData[column] = index
      })
      return sortData
    },
    dragHoveredColumnIndex () {
      return this.dragHoveredColumn && this.sortDataForColumnsObj[this.getUniqueColumnKey(this.dragHoveredColumn)]
    }
  },
  watch: {
    remoteTrigger (val) {
      if (val && this.isChangeTrigger) {
        this.loadData({ init: true })
      }
    },
    items () {
      this.selectableItems = this.items.map(item => {
        return { item, _isSelected: false }
      })
      if (Object.keys(this.openedSubTableStates).length > 0) {
        for (let state in this.openedSubTableStates) {
          if (this.openedSubTableStates[state]) {
            const target = this.selectableItems.find(item => item.item.uuid === state)
            if (target) {
              this.$set(target.item, 'isOpenedSubTable', true)
            }
          }
        }
      }
    },
    localItems () {
      this.selectableItems = this.localItems.map(item => {
        return { item, _isSelected: false }
      })
    },
    columns: {
      immediate: true,
      deep: true,
      handler () {
        this.prepareColumns()
      }
    },
    searchQuery (query) {
      this.handleSearch(query)
    },
    groupsList (val) {
      this.initGroups(val)
    },
    checkedRows: {
      handler: function (rows) {
        this.selectedUuids = rows
      },
      immediate: true
    }
  },
  created () {
    this.$eventGlobal.$on('tableNextRow', this.tableNextRows)
    this.$eventGlobal.$on('tablePrevRow', this.tablePrevRows)

    if (!this.columns.find(column => column.uuid === 'checkboxColumn')) {
      this.columns.unshift({
        exactWidth: '56px', // The smallest width as possible
        sortDisable: true,
        slotName: 'obCheckbox',
        // Copy 'fixed' property from first column,
        // because otherwise checkbox will be static
        // while right columns will be fixed - so strange
        fixed: this.columns[0]?.fixed || false,
        uuid: 'checkboxColumn',
        isToggleDisabled: true,
        _isEnabled: false
      })

      if (this.isUseSubTable) {
        this.columns.unshift({
          exactWidth: '56px', // The smallest width as possible
          sortDisable: true,
          slotName: 'obSubTableToggler',
          // Copy 'fixed' property from first column,
          // because otherwise checkbox will be static
          // while right columns will be fixed - so strange
          fixed: this.columns[0]?.fixed || false,
          uuid: 'obSubTableTogglerColumn',
          isToggleDisabled: true,
          _isEnabled: true
        })
      }
    }

    this.prepareColumns()

    if (this.items.length) {
      this.selectableItems = this.items.map(item => {
        return { item, _isSelected: false }
      })
    }

    if (!this.itemsHaveAllProperties) {
      console.warn(`ob-table: Object properties don't match columns fields (missing prop)`)
    }
  },
  mounted () {
    this.$nextTick(function () {
      this.resize()
    })
    window.addEventListener('resize', this.resize)
    this.checkInitParams()
    this.$nextTick(async () => {
      await this.loadData({ init: true })
      this.initGroups(this.groupsList)
    })
    // If table have scrolling area, show 'showMore' element
    this.isShowMore = this.$refs.tableItemObj.scrollWidth > this.$refs.tableItemObj.clientWidth
    this.isPaginationWide = this.$refs.tableItemObj.clientWidth > 650

    if (this.isFixedHeader) {
      let needClass = true
      let parent = this.$refs.container.parentElement
      while (needClass) {
        if (parent.classList.contains('table-container') ||
            parent.classList.contains('ob-main-template-content') ||
            parent.classList.contains('ob-two-panel-container')
        ) {
          needClass = false
        } else {
          parent.classList.add('-fixed-header-helper')
          parent = parent.parentElement
        }
      }
    }
  },
  beforeDestroy () {
    window.removeEventListener('resize', this.resize)
    clearTimeout(this.updateDataTO)
  },
  methods: {
    tableRowClasses (item, isGroups = false) {
      return [
        'data-row',
        this.rowClassFunc(item),
        { 'groups-row': isGroups },
        { 'row-selected': item._isSelected },
        { 'clickable': this.hasSelectListener }
      ]
    },
    onDragStart () {
      clearTimeout(this.dragTimeout)
      this.dragged = false
      this.dragTimeout = setTimeout(() => { this.dragged = true }, 100) // Задержка, чтобы убедиться, что это drag, а не click
    },
    onDragClick (e) {
      if (this.dragged) {
        e.stopPropagation()
      }
      this.dragged = false
    },
    getSavedDataForColumns () {
      let currentItems = this.columns
      let savedSortData = JSON.parse(localStorage.getItem(`ob-table-${this.componentUniqueKey}-sort-data`)) || []
      let savedVisibleData = JSON.parse(localStorage.getItem(`ob-table-${this.componentUniqueKey}-visible-columns-data`)) || []
      let deletedItems = []

      currentItems.forEach((item, index) => {
        if (!savedSortData.includes(this.getUniqueColumnKey(item))) {
          savedSortData.splice(index, 0, this.getUniqueColumnKey(item))
          if (!item.hasOwnProperty('_isEnabled') || item._isEnabled) {
            savedVisibleData.push(this.getUniqueColumnKey(item))
          }
        }
      })
      savedSortData.forEach((item) => {
        if (!currentItems.find(currentItem => this.getUniqueColumnKey(currentItem) === item)) {
          deletedItems.push(item)
        }
      })

      return {
        sortData: savedSortData.filter(savedItem => !deletedItems.includes(savedItem)),
        visibleData: savedVisibleData.filter(savedItem => !deletedItems.includes(savedItem))
      }
    },
    prepareColumns () {
      let { sortData, visibleData } = this.getSavedDataForColumns()
      this.modifiedColumns = cloneDeep(this.columns).map((column) => {
        let _isEnabled = column.hasOwnProperty('_isEnabled') ? column._isEnabled : true
        let _isEnabledSaved = visibleData.includes(this.getUniqueColumnKey(column))

        return {
          ...column,
          uuid: column.hasOwnProperty('uuid') ? column.uuid : uuid.v4(),
          _isEnabled: !_isEnabledSaved ? false : _isEnabled
        }
      })
      this.sortDataForColumns = sortData
      if (this.componentUniqueKey) {
        localStorage.setItem(`ob-table-${this.componentUniqueKey}-sort-data`, JSON.stringify(sortData))
        localStorage.setItem(`ob-table-${this.componentUniqueKey}-visible-columns-data`, JSON.stringify(visibleData))
      }
    },
    getUniqueColumnKey (column) {
      return column.key || column.slotName
    },
    onChangeFilterButton (e) {
      if (!this.filterButtons.length) return
      this.$emit('on-change-filter-button', e)
    },
    resize () {
      this.handleBodyUpdate(this.$refs.tableDataObj)
    },
    handleHeaderUpdate: function (el) {
      this.tableHeaderHeight = el.offsetHeight
    },
    compareArray (a1, a2) {
      return a1.length === a2.length && a1.every((v, i) => v === a2[i])
    },
    handleBodyUpdate: function (el) {
      let row = el.getElementsByClassName('data-row')[0]
      if (row) {
        let tw = []
        for (let i = 0; i < row.cells.length; i++) {
          tw.push(row.cells[i].offsetWidth)
        }
        if (!this.compareArray(tw, this.tableColumnsWidths)) {
          this.tableColumnsWidths = tw
        }
      }
      this.isPaginationWide = this.$refs.tableItemObj.clientWidth > 650
    },
    getUpdateActives () {
      for (let i in this.currentItems) {
        let itemActive = this.currentItems[i].item
        let num = Number(i)
        if (itemActive.uuid === this.activeItem.uuid) {
          this.activeItems.next = this.currentItems[num + 1] ? this.currentItems[num + 1].item : null
          this.activeItems.prev = this.currentItems[num - 1] ? this.currentItems[num - 1].item : null
        }
      }
      if (!this.activeItems.next) {
        this.$eventGlobal.$emit('hideArrowNext')
      } else {
        this.$eventGlobal.$emit('showArrowNext')
      }
      if (!this.activeItems.prev) {
        this.$eventGlobal.$emit('hideArrowPrev')
      } else {
        this.$eventGlobal.$emit('showArrowPrev')
      }
    },
    tableNextRows () {
      this.obNextEl = this.activeItems.next
      if (this.obNextEl) {
        this.activeItem = this.obNextEl
        this.getUpdateActives()
        this.$emit('select', this.activeItem)
      }
    },
    tablePrevRows () {
      this.obPrevEl = this.activeItems.prev
      if (this.obPrevEl) {
        this.activeItem = this.obPrevEl
        this.getUpdateActives()
        this.$emit('select', this.activeItem)
      }
    },
    checkInitParams () {
      if (this.sortInit) {
        let sortParams = this.sortInit.split(':')
        this.sort = {
          key: sortParams[0],
          direction: Boolean(sortParams[1] === 'desc'),
          type: sortParams[2] || null
        }
      }
    },
    initGroups (val) {
      this.groups = []
      if (val && val.length) {
        val.forEach((item, index) => {
          this.$set(this.groups, [index], {
            opened: this.localOpenedGroups[item] ?? this.isGroupsOpened,
            value: item
          })
        })
      }
    },
    toggleGroup (index) {
      let open = (this.localOpenedGroups[this.groups[index].value] === undefined && this.isGroupsOpened ? false : Boolean(!this.localOpenedGroups[this.groups[index].value]))
      this.$set(this.localOpenedGroups, this.groups[index].value, open)
      this.groups[index].opened = this.localOpenedGroups[this.groups[index].value]
    },
    onSearch (query) {
      this.handleSearch(query)
    },
    handleSearch (query) {
      if (query === this.search) return
      if (this.isRemote) {
        this.loadData({ init: true, search: query })
      } else {
        this.search = query
        this.page = 0
      }
    },
    onAdd (item) {
      this.$emit('add', item)
    },
    onEdit () {
      this.$emit('onEdit')
    },
    onRefresh () {
      this.$emit('onRefresh')
    },
    onChangePage (page) {
      if (page !== this.page) {
        this.page = page
        this.loadData()
      }
      this.$emit('onChangePage', page)
    },
    onToggleColumnVisibility (column) {
      this.modifiedColumns.find(col => col.uuid === column.uuid)._isEnabled = column._isEnabled
      let enabledColumns = this.modifiedColumns.filter(column => column._isEnabled).map(column => this.getUniqueColumnKey(column))
      localStorage.setItem(`ob-table-${this.componentUniqueKey}-visible-columns-data`, JSON.stringify(enabledColumns))
    },
    processData (res) {
      let processedData = res

      if (processedData && typeof processedData === 'object' && Object.keys(processedData).length === 1 && res.data) {
        processedData = processedData.data
      }

      let error = !processedData || processedData.error
      let total = processedData.total_elements || processedData.totalElements || null
      let result = processedData
      let customKeyContent = this.isRemoteObject ? this.remoteOpt.contentKey : null

      if (result && !Array.isArray(result)) {
        result = (customKeyContent && result[customKeyContent]) || result.content || result.values || []
      } else if (!result) {
        result = []
      }

      return {
        items: result,
        total,
        error
      }
    },
    async loadData ({ concat = false, init = false, page, sort, search, auto = false } = {}) {
      clearTimeout(this.updateDataTO)

      if (!auto) {
        this.isLocalLoading = true
      }

      try {
        if (this.isLoadReady) {
          let promise = this.isRemoteFunction ? this.remoteOpt : this.remoteOpt.method
          let res = await promise(({ ...this.getRequestParams({ search, init, page, sort }) }))

          let processedData = this.processData(res)
          let total = processedData.total
          let result = processedData.items

          if (this.isSmartPagination && total && +total <= 100 && result.length < total) {
            res = await promise(({ ...this.getRequestParams({ search, init, page, sort, size: total }) }))
          }

          processedData = this.processData(res)
          total = processedData.total
          result = processedData.items

          if (processedData.error) {
            result = this.localItems
          }

          if (init) {
            this.page = 0
          }
          this.count = total
          const localItems = concat ? this.localItems.concat(result) : result
          if (this.isUseSubTable) {
            this.localItems = localItems.map(item => {
              const savedState = this.openedSubTableStates[item.uuid]
              if (savedState !== undefined) {
                item.isOpenedSubTable = savedState
                if (item.isOpenedSubTable) {
                  let ref = this.$refs[`sub-table-${item.uuid}`]
                  if (ref && ref[0]) {
                    ref[0].loadData()
                  }
                }
              }
              return item
            })
          } else {
            this.localItems = localItems
          }
          this.prevTrigger = this.remoteTrigger
          this.firstLoad = false
          this.search = search !== undefined ? search : this.search
          this.$emit('on-load-list', this.localItems)
        } else {
          if (!this.isRemote) {
            this.localItems = this.items || []
          }
        }

        // Resetting groups state and selected uuids
        // when new data are loaded
        // this.groupsState = []
        // this.selectedUuids = []
      } catch (e) {
        console.log(e)
        if (e && e.code && e.code === 10002) {
          this.sort = {
            key: null,
            type: null,
            direction: false
          }
        }
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        })
      } finally {
        this.isLocalLoading = false
        if (this.updateTimeout && this.isRemote) {
          const TO = this.updateTimeout < 5000 ? 5000 : this.updateTimeout
          this.updateDataTO = setTimeout(() => {
            this.loadData({ auto: true })
          }, TO)
        }
      }
    },
    getRequestParams ({ search, init, page, sort, size = this.pageLimit } = {}) {
      if (init) {
        page = 0
      } else {
        page = page !== undefined ? page : this.page
      }

      if (sort === undefined) {
        sort = this.sort
      }

      let filter

      if (this.filters) {
        filter = this.filters

        if (this.filtersHandler) {
          // If developer needs to change 'filter' parameter before sending it to API
          filter = this.filtersHandler({ filters: this.filters })
        }

        filter = filter.map(({ key, value }) => `${key},${value}`).join(';')
      }

      let params = {
        size,
        query: search !== undefined ? search : this.search,
        page: page,
        total: this.count,
        filter
      }

      if (sort && sort.key) {
        params.sort = `${sort.key},${sort.direction ? 'desc' : 'asc'}`
      }

      let userArguments = {}

      if (this.isRemoteObject && this.remoteOpt.arguments) {
        userArguments = this.remoteOpt.arguments
      }

      if (filter) {
        params.filter = filter
      }

      return {
        ...params,
        ...userArguments
      }
    },
    onCheckAll () {
      this.$emit('onCheckAll')
    },
    onSelect ({ data, e }) {
      // If we are clicking on checkbox, stop row selecting (open modal/do action)
      if (e.target.className === 'input-visual' || e.target.className === 'left-col') return
      this.$emit('select', data.item)
      this.activeItem = data.item
      this.getUpdateActives()
      if (this.isCssSelectable) {
        this.deselect()
        data._isSelected = true
      }
    },
    deselect () {
      this.selectableItems.forEach(item => {
        item._isSelected = false
      })
    },
    onSorting (objSort) {
      this.sort = objSort
      if (this.isRemote) {
        this.loadData({ sort: this.sort })
      }
    },
    getTableCellHtml (item, column) {
      return column.html
        ? this.markWithSearchQuery(column.html(item))
        : item.hasOwnProperty(column.key)
          ? this.markWithSearchQuery(item[column.key])
          : '<div class="missing-property">missing property</div>'
    },
    markWithSearchQuery (cellHtml) {
      // Not an empty string, false, null etc
      if (typeof cellHtml !== 'object' && typeof cellHtml !== 'undefined') {
        cellHtml = cellHtml.toString()

        const cleanString = cellHtml.replace(/<[^>]*>?/gm, '').replace(/\s\s+/g, ' ').trim()

        let reg = `(${this.search})`
        let regex = new RegExp(reg, 'i')

        if (!cleanString.match(regex)) {
          return cellHtml
        }

        let matchStartPosition = cleanString.match(regex).index
        let matchEndPosition = matchStartPosition + cleanString.match(regex)[0].toString().length
        let originalTextFoundByRegex = cleanString.substring(matchStartPosition, matchEndPosition)
        cellHtml = cellHtml.replace(regex, `<mark>${originalTextFoundByRegex}</mark>`)
      }

      return cellHtml
    },

    onTableCellClick (e, item, column) {
      if (column.action) {
        e.stopPropagation()
        column.action(item)
      }
    },

    getColumnStyle (column) {
      return {
        width: `${column.width}px` || 'auto'
      }
    },
    checkShowMoreVisibility () {
      // Just to get visually more short condition notation
      const element = this.$refs.tableItemObj
      // Hide 'showMore' element if user scrolled the whole table
      this.isShowMore = element.scrollWidth - element.clientWidth - element.scrollLeft > 0
    },
    onGroupToggle (groupIndex, value) {
      const itemsToRemove = []

      this.groupCurrentList[groupIndex].items.forEach(({ item }) => {
        if (value) {
          this.selectedUuids.push(item.uuid)
        } else {
          itemsToRemove.push(item.uuid)
        }
      })

      this.selectedUuids = this.selectedUuids.filter((uuid) => {
        return !itemsToRemove.includes(uuid)
      })

      this.$emit('group-toggle', this.groupCurrentList[groupIndex].items.map((item) => {
        // Prettify item object to remove unnecessary
        // information, like '_isSelected' property
        return item.item
      }), this.selectedUuids, groupIndex, value)
    },
    onRowToggle (item, value) {
      if (value) {
        this.selectedUuids.push(item.uuid)
      } else {
        this.selectedUuids = this.selectedUuids.filter((uuid) => {
          return uuid !== item.uuid
        })
      }

      this.$emit('row-toggle', item, this.selectedUuids)
    },
    onSubTableToggle (item) {
      const opened = !item.item.isOpenedSubTable
      this.$set(item.item, 'isOpenedSubTable', opened)
      this.openedSubTableStates[item.item.uuid] = opened
    },
    subRemoteOptConfig (item) {
      if (this.isUseSubTable && this.subRemoteOpt) {
        const _subRemoteOpt = this.subRemoteOpt
        if (typeof this.subRemoteOpt === 'function') {
          return function () {
            return _subRemoteOpt.apply(this, [item, ...arguments])
          }
        } else if (this.subRemoteOpt.method) {
          let opts = Object.assign({}, _subRemoteOpt)
          opts.method = function () {
            return _subRemoteOpt.method.apply(this, [item, ...arguments])
          }
          return opts
        }
      } else {
        return null
      }
    },
    async onFilterChanged ({ column, filters }) {
      const found = this.filters.find(item => item.key === column.key)

      if (found) {
        if (filters) { // Filter was added
          found.value = filters.join(',')
        } else { // All filters for column was removed
          this.filters.splice(this.filters.indexOf(found), 1)
        }
      } else {
        // There is a new filter
        this.filters.push({
          key: column.key,
          value: filters.join(',')
        })
      }

      this.$emit('on-column-filter-changed', { column, filters, allFilters: this.filters })
      if (!this.isRemote) {
        this.page = 0
      }
      await this.loadData({ init: true, sort: this.sort, search: this.search })
    },
    dragMouseDownHandler (e, column) {
      if (!this.componentUniqueKey || this.isSubTable || !column.key) return
      this.draggingCell = e.target.closest('th')
      this.draggingCellIndex = this.sortDataForColumnsObj[this.getUniqueColumnKey(column)]
      this.tableBound = this.$refs.tableDataObj.getBoundingClientRect()
      this.cellsBound = Array.from(this.$refs.tableDataObj.querySelectorAll('th')).map(cell => {
        return cell.getBoundingClientRect()
      })

      document.addEventListener('mousemove', this.dragMouseMoveHandler)
      document.addEventListener('mouseup', this.dragMouseUpHandler)
    },
    dragMouseMoveHandler (e) {
      if (!this.isDragging) {
        this.isDragging = true

        this.dragCloneElement()
      } else {
        const x = e.clientX
        const y = e.clientY
        this.draggingBlockPosLeft = x - (this.draggingBlockWidth / 2)
        this.draggingBlockPosTop = y - (this.draggingBlockHeight / 2)
        this.draggingBlock.style.left = this.draggingBlockPosLeft + 'px'
        this.draggingBlock.style.top = this.draggingBlockPosTop + 'px'
        if (x <= this.tableBound.left || x > this.tableBound.right || y <= this.tableBound.top || y >= this.tableBound.bottom) {
          this.dragHoveredColumn = null
        } else {
          this.cellsBound.some((cell, index) => {
            const isCorrectIndex = x > cell.left && x <= cell.right
            if (isCorrectIndex) {
              this.dragHoveredColumn = this.filteredColumns[index]
            }
            return isCorrectIndex
          })
        }
      }
    },
    dragMouseUpHandler () {
      document.removeEventListener('mousemove', this.dragMouseMoveHandler)
      document.removeEventListener('mouseup', this.dragMouseUpHandler)
      document.body.removeChild(this.draggingBlock)
      if (this.dragHoveredColumn?.key) {
        const newSortData = {}

        this.sortDataForColumns.forEach((column, index) => {
          if (this.dragHoveredColumn !== null && this.draggingCellIndex !== this.dragHoveredColumnIndex) {
            if (index === this.draggingCellIndex) {
              newSortData[column] = this.dragHoveredColumnIndex
            } else if (index === this.dragHoveredColumnIndex) {
              newSortData[column] = this.draggingCellIndex
            } else {
              newSortData[column] = index
            }
          }
          return column
        })

        this.sortDataForColumns = this.sortDataForColumns.sort((a, b) => {
          return newSortData[a] - newSortData[b]
        })

        if (this.componentUniqueKey) {
          localStorage.setItem(`ob-table-${this.componentUniqueKey}-sort-data`, JSON.stringify(this.sortDataForColumns))
        }
      }
      this.$nextTick(() => {
        this.isDragging = false
        this.dragHoveredColumn = null
      })
    },
    dragCloneElement () {
      this.draggingBlockWidth = parseInt(window.getComputedStyle(this.draggingCell).width)
      this.draggingBlockHeight = parseInt(window.getComputedStyle(this.draggingCell).height)

      this.draggingBlock = document.createElement('div')
      this.draggingBlock.classList.add('draggable')
      this.draggingBlock.style.position = 'fixed'
      this.draggingBlock.style.zIndex = '5000'
      this.draggingBlock.style.boxShadow = 'inset 0 0 2px 2px #e5edf9'

      const newTable = document.createElement('table')
      const newCell = this.draggingCell.cloneNode(true)
      newCell.style.background = '#fff'
      newCell.style.width = this.draggingBlockWidth + 'px'
      const newRow = document.createElement('tr')
      newRow.appendChild(newCell)
      newTable.appendChild(newRow)

      this.draggingBlock.appendChild(newTable)
      document.body.appendChild(this.draggingBlock)
    }
  }
}
</script>
<style lang="scss" scoped>
@import "../../static/css/table-style";
</style>
